"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.width = exports.scale = exports.height = exports.fontScale = exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));
var _reactNativeGestureHandler = require("react-native-gesture-handler");
var _reactNativeRedash = require("react-native-redash");
var _useMemoOne = require("use-memo-one");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
const {
  width,
  height,
  scale,
  fontScale
} = _reactNative.Dimensions.get('window');
exports.fontScale = fontScale;
exports.scale = scale;
exports.height = height;
exports.width = width;
const EXPANDEDTARGET = height;
const WrapDraggable = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  const {
    goDown,
    enableDraggable
  } = props;
  const [translationY, velocityY, translateY, snapBack, state] = (0, _reactNativeRedash.useValues)(0, 0, 0, 0, 0, _reactNativeGestureHandler.State.UNDETERMINED);
  (0, _react.useImperativeHandle)(ref, () => ({
    resetAnimationValue() {
      translationY === null || translationY === void 0 ? void 0 : translationY.setValue(0);
      velocityY === null || velocityY === void 0 ? void 0 : velocityY.setValue(0);
      translateY === null || translateY === void 0 ? void 0 : translateY.setValue(0);
      snapBack === null || snapBack === void 0 ? void 0 : snapBack.setValue(0);
      state === null || state === void 0 ? void 0 : state.setValue(_reactNativeGestureHandler.State.UNDETERMINED);
    }
  }));
  // @ts-ignore
  const snapTo = (0, _reactNativeRedash.snapPoint)(translationY, velocityY, [0, height]);

  // @ts-ignore
  const gestureHandler = (0, _useMemoOne.useMemoOne)(() => (0, _reactNativeRedash.onGestureEvent)({
    translationY,
    velocityY,
    state
  }), [state, translationY, velocityY]);
  // @ts-ignore
  const opacity = (0, _reactNativeReanimated.interpolate)(translateY, {
    inputRange: [0, EXPANDEDTARGET * 2],
    outputRange: [1, 0]
  });
  (0, _reactNativeReanimated.useCode)(() => (0, _reactNativeReanimated.block)([(0, _reactNativeReanimated.cond)(
  // @ts-ignore
  (0, _reactNativeReanimated.and)((0, _reactNativeReanimated.eq)(state, _reactNativeGestureHandler.State.END), (0, _reactNativeReanimated.eq)(snapTo, height), (0, _reactNativeReanimated.eq)(snapBack, 0)),
  // @ts-ignore
  (0, _reactNativeReanimated.set)(snapBack, 1)
  // set(toggle, greaterThan(height, translateY))
  ), (0, _reactNativeReanimated.cond)(
  // @ts-ignore
  snapBack, (0, _reactNativeReanimated.call)([], () => resetTranslate()), (0, _reactNativeReanimated.cond)(
  // @ts-ignore
  (0, _reactNativeReanimated.eq)(state, _reactNativeGestureHandler.State.END), [(0, _reactNativeReanimated.set)(
  // @ts-ignore
  translateY, (0, _reactNativeRedash.timing)({
    from: translationY,
    to: 0,
    duration: 250
  }))],
  // @ts-ignore
  [(0, _reactNativeReanimated.set)(translateY, translationY)]))]), []);
  const resetTranslate = () => {
    goDown();
  };
  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.PanGestureHandler, _extends({}, gestureHandler, {
    enabled: enableDraggable
  }), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: {
      flex: 1,
      opacity,
      transform: [{
        translateY
      }]
    }
  }, props.children));
});
var _default = WrapDraggable;
exports.default = _default;
//# sourceMappingURL=index.js.map