"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNativeReanimated = _interopRequireDefault(require("react-native-reanimated"));
var _PlayerSong = _interopRequireDefault(require("../PlayerSong"));
var _useMiniPlayer = _interopRequireDefault(require("../../hooks/useMiniPlayer"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const WrapPlayer = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
  const {
    children,
    renderUiFullScreen,
    renderMiniPlayer,
    hide = false,
    enableDraggable = false,
    tabBarHeight,
    miniPlayerHeight,
    header
  } = props;
  const {
    translateY,
    translateBottomTab,
    goUpPlayer,
    goDownPlayer,
    opacity,
    opacityMiniPayer,
    refPlayer,
    maxHeightAnimation,
    pointerEvents
  } = (0, _useMiniPlayer.default)(tabBarHeight, miniPlayerHeight);
  (0, _react.useImperativeHandle)(ref, () => ({
    open() {
      goUpPlayer();
    },
    close() {
      goDownPlayer();
    }
  }));
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, hide ? null : /*#__PURE__*/_react.default.createElement(_PlayerSong.default, {
    maxHeightAnimation: maxHeightAnimation,
    opaciTyPlayer: opacity,
    opaciTyMiniPlayer: opacityMiniPayer,
    translateY: translateY,
    goDown: goDownPlayer,
    goUp: goUpPlayer,
    ref: refPlayer,
    renderUiFullScreen: renderUiFullScreen,
    renderMiniPlayer: renderMiniPlayer,
    pointerEventsMiniPlayer: pointerEvents,
    tabBarHeight: tabBarHeight,
    header: header,
    enableDraggable: enableDraggable
  }), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: [{
      transform: [{
        translateY: translateBottomTab
      }]
    }]
  }, children));
});
var _default = WrapPlayer;
exports.default = _default;
//# sourceMappingURL=index.js.map