"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refPlayer = exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeReanimated = _interopRequireDefault(require("react-native-reanimated"));
var _reactNativeRedash = require("react-native-redash");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const {
  height
} = _reactNative.Dimensions.get('window');
const TABBAR_HEIGHT = 80; //height of bottom tab
const MINIMIZED_PLAYER_HEIGHT = 80; //maximun height of miniplayer
const SNAP_TOP = 0;
const SNAP_BOTTOM = height;
const config = {
  damping: 15,
  mass: 1,
  stiffness: 150,
  overshootClamping: false,
  restSpeedThreshold: 0.1,
  restDisplacementThreshold: 0.1
};
const {
  Clock,
  Value,
  cond,
  useCode,
  set,
  block,
  not,
  clockRunning,
  interpolate,
  Extrapolate
} = _reactNativeReanimated.default;
_reactNative.LogBox.ignoreLogs(['useCode() first argument should be a function that returns an animation node.']);
const refPlayer = /*#__PURE__*/_react.default.createRef();
exports.refPlayer = refPlayer;
const useMiniPlayer = function () {
  let tabBarHeight = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : TABBAR_HEIGHT;
  let miniPlayerHeight = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : MINIMIZED_PLAYER_HEIGHT;
  const translationY = (0, _react.useRef)(new Value(0));
  const velocityY = (0, _react.useRef)(new Value(0));
  const state = (0, _react.useRef)(new Value(0));
  const offset = new Value(SNAP_BOTTOM);
  const goUp = (0, _react.useRef)(new Value(0));
  const goDown = (0, _react.useRef)(new Value(0));
  const translateY = (0, _react.useRef)((0, _reactNativeRedash.clamp)((0, _reactNativeRedash.withSpring)({
    state: state.current,
    value: translationY.current,
    velocity: velocityY.current,
    offset,
    snapPoints: [SNAP_TOP, SNAP_BOTTOM],
    config
  }), SNAP_TOP, SNAP_BOTTOM));
  const translateBottomTab = interpolate(translateY.current, {
    inputRange: [SNAP_TOP, SNAP_BOTTOM],
    outputRange: [tabBarHeight, 0],
    extrapolate: Extrapolate.CLAMP
  });
  const opacity = interpolate(translateY.current, {
    inputRange: [SNAP_BOTTOM - miniPlayerHeight, SNAP_BOTTOM],
    outputRange: [0, 1],
    extrapolate: Extrapolate.CLAMP
  });
  const opacityMiniPayer = interpolate(translateY.current, {
    inputRange: [SNAP_BOTTOM - miniPlayerHeight * 2, SNAP_BOTTOM - miniPlayerHeight],
    outputRange: [0, 1],
    extrapolate: Extrapolate.CLAMP
  });
  const maxHeightAnimation = interpolate(translateY.current, {
    inputRange: [SNAP_BOTTOM - miniPlayerHeight * 2, SNAP_BOTTOM - miniPlayerHeight],
    outputRange: [0, 120],
    extrapolate: Extrapolate.CLAMP
  });
  const pointerEvents = cond(translateY.current, 'auto', 'none');
  const clock = new Clock();
  useCode(
  // eslint-disable-next-line @typescript-eslint/ban-ts-ignore
  // @ts-ignore
  block([cond(goUp.current, [set(offset, (0, _reactNativeRedash.timing)({
    clock,
    from: offset,
    to: SNAP_TOP
  })), cond(not(clockRunning(clock)), [set(goUp.current, 0)])]), cond(goDown.current, [set(offset, (0, _reactNativeRedash.timing)({
    clock,
    from: offset,
    to: SNAP_BOTTOM
  })), cond(not(clockRunning(clock)), [set(goDown.current, 0)])])]), []);
  const goUpPlayer = () => {
    var _refPlayer$current;
    goUp.current.setValue(1);
    (_refPlayer$current = refPlayer.current) === null || _refPlayer$current === void 0 ? void 0 : _refPlayer$current.resetAnimationValue();
  };
  const goDownPlayer = () => {
    goDown.current.setValue(1);
  };
  return {
    translateY: translateY.current,
    translateBottomTab: translateBottomTab,
    opacity,
    opacityMiniPayer,
    goUpPlayer,
    goDownPlayer,
    refPlayer,
    maxHeightAnimation,
    pointerEvents
  };
};
var _default = useMiniPlayer;
exports.default = _default;
//# sourceMappingURL=useMiniPlayer.js.map