import React, { forwardRef, useImperativeHandle, useRef } from 'react';
import { TouchableWithoutFeedback, View } from 'react-native';
import Animated from 'react-native-reanimated';
import { styles } from '../style';
// import WrapDraggable from '../WrapDraggable';

const PlayerSong = /*#__PURE__*/forwardRef((props, ref) => {
  const {
    pointerEventsMiniPlayer,
    opaciTyMiniPlayer,
    translateY,
    maxHeightAnimation,
    tabBarHeight = 80,
    containerMiniPlayer,
    goDown,
    goUp,
    renderMiniPlayer,
    renderUiFullScreen
  } = props;
  const refWarapDaraggable = useRef(null);
  useImperativeHandle(ref, () => ({
    goUpPlayer() {
      goUp();
    },
    goDownPlayer() {
      goDown();
    },
    resetAnimationValue() {
      var _refWarapDaraggable$c;
      // @ts-ignore
      (_refWarapDaraggable$c = refWarapDaraggable.current) === null || _refWarapDaraggable$c === void 0 ? void 0 : _refWarapDaraggable$c.resetAnimationValue();
    }
  }));
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Animated.View, {
    style: [styles.playerSheet, {
      transform: [{
        translateY
      }]
    }]
  }, renderUiFullScreen()), /*#__PURE__*/React.createElement(Animated.View, {
    pointerEvents: pointerEventsMiniPlayer,
    style: [styles.miniPlayer, {
      bottom: tabBarHeight
    }, containerMiniPlayer, {
      opacity: opaciTyMiniPlayer,
      maxHeight: maxHeightAnimation
    }]
  }, /*#__PURE__*/React.createElement(TouchableWithoutFeedback, {
    onPress: goUp
  }, /*#__PURE__*/React.createElement(View, null, renderMiniPlayer()))));
});
export default /*#__PURE__*/React.memo(PlayerSong);
//# sourceMappingURL=index.js.map