function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { forwardRef, useImperativeHandle } from "react";
import { Dimensions } from "react-native";
import Animated, { and, block, call, cond, eq, interpolate, set, useCode } from "react-native-reanimated";
import { PanGestureHandler, State } from "react-native-gesture-handler";
import { onGestureEvent, snapPoint, timing, useValues } from "react-native-redash";
import { useMemoOne } from "use-memo-one";
export const {
  width,
  height,
  scale,
  fontScale
} = Dimensions.get('window');
const EXPANDEDTARGET = height;
const WrapDraggable = /*#__PURE__*/forwardRef((props, ref) => {
  const {
    goDown,
    enableDraggable
  } = props;
  const [translationY, velocityY, translateY, snapBack, state] = useValues(0, 0, 0, 0, 0, State.UNDETERMINED);
  useImperativeHandle(ref, () => ({
    resetAnimationValue() {
      translationY === null || translationY === void 0 ? void 0 : translationY.setValue(0);
      velocityY === null || velocityY === void 0 ? void 0 : velocityY.setValue(0);
      translateY === null || translateY === void 0 ? void 0 : translateY.setValue(0);
      snapBack === null || snapBack === void 0 ? void 0 : snapBack.setValue(0);
      state === null || state === void 0 ? void 0 : state.setValue(State.UNDETERMINED);
    }
  }));
  // @ts-ignore
  const snapTo = snapPoint(translationY, velocityY, [0, height]);

  // @ts-ignore
  const gestureHandler = useMemoOne(() => onGestureEvent({
    translationY,
    velocityY,
    state
  }), [state, translationY, velocityY]);
  // @ts-ignore
  const opacity = interpolate(translateY, {
    inputRange: [0, EXPANDEDTARGET * 2],
    outputRange: [1, 0]
  });
  useCode(() => block([cond(
  // @ts-ignore
  and(eq(state, State.END), eq(snapTo, height), eq(snapBack, 0)),
  // @ts-ignore
  set(snapBack, 1)
  // set(toggle, greaterThan(height, translateY))
  ), cond(
  // @ts-ignore
  snapBack, call([], () => resetTranslate()), cond(
  // @ts-ignore
  eq(state, State.END), [set(
  // @ts-ignore
  translateY, timing({
    from: translationY,
    to: 0,
    duration: 250
  }))],
  // @ts-ignore
  [set(translateY, translationY)]))]), []);
  const resetTranslate = () => {
    goDown();
  };
  return /*#__PURE__*/React.createElement(PanGestureHandler, _extends({}, gestureHandler, {
    enabled: enableDraggable
  }), /*#__PURE__*/React.createElement(Animated.View, {
    style: {
      flex: 1,
      opacity,
      transform: [{
        translateY
      }]
    }
  }, props.children));
});
export default WrapDraggable;
//# sourceMappingURL=index.js.map