import React, { forwardRef, useImperativeHandle } from "react";
import Animated from "react-native-reanimated";
import PlayerSong from "../PlayerSong";
import useMiniPlayer from "../../hooks/useMiniPlayer";
const WrapPlayer = /*#__PURE__*/forwardRef((props, ref) => {
  const {
    children,
    renderUiFullScreen,
    renderMiniPlayer,
    hide = false,
    enableDraggable = false,
    tabBarHeight,
    miniPlayerHeight,
    header
  } = props;
  const {
    translateY,
    translateBottomTab,
    goUpPlayer,
    goDownPlayer,
    opacity,
    opacityMiniPayer,
    refPlayer,
    maxHeightAnimation,
    pointerEvents
  } = useMiniPlayer(tabBarHeight, miniPlayerHeight);
  useImperativeHandle(ref, () => ({
    open() {
      goUpPlayer();
    },
    close() {
      goDownPlayer();
    }
  }));
  return /*#__PURE__*/React.createElement(React.Fragment, null, hide ? null : /*#__PURE__*/React.createElement(PlayerSong, {
    maxHeightAnimation: maxHeightAnimation,
    opaciTyPlayer: opacity,
    opaciTyMiniPlayer: opacityMiniPayer,
    translateY: translateY,
    goDown: goDownPlayer,
    goUp: goUpPlayer,
    ref: refPlayer,
    renderUiFullScreen: renderUiFullScreen,
    renderMiniPlayer: renderMiniPlayer,
    pointerEventsMiniPlayer: pointerEvents,
    tabBarHeight: tabBarHeight,
    header: header,
    enableDraggable: enableDraggable
  }), /*#__PURE__*/React.createElement(Animated.View, {
    style: [{
      transform: [{
        translateY: translateBottomTab
      }]
    }]
  }, children));
});
export default WrapPlayer;
//# sourceMappingURL=index.js.map